<?php

App::uses('BuzzStaffRotasAppController', 'BuzzStaffRotas.Controller');

class StaffRotasController extends BuzzStaffRotasAppController {

	public function beforeFilter() {
		parent::beforeFilter();
		$this->Auth->allow(['index', 'rota']);
	}

	/**
	 * Index displays the form and handles the submitted response, building the
	 * url that the user is redirected to.
	 */
	public function index() {
		$Model = $this->{$this->modelClass};
		if (!empty($this->request->data)) {
			$filters = $this->request->data['filter'];
			$Model->set($filters);
			if ($Model->validates()) {
				// Build the date in the right format.
				$date = $filters['Date'];
				$department = (!empty($filters['Department'])) ? strtolower($filters['Department']) : '';
				$username = (!empty($filters['Username'])) ? strtolower($filters['Username']) : '';
				return $this->redirect(
					[
						'action' => 'rota',
						$date,
						$department,
						$username
					]
				);
			} else {
				// Filters do not validate.
			}
		}
	}

	public function rota($date, $department = null, $user = null) {
		$Model = $this->{$this->modelClass};
		$alias = $Model->alias;

		$this->loadModel('BuzzStaffRotas.StaffRotaApi');
		$records = $this->StaffRotaApi->getRotaRecords($date, $department, $user);
		$data = $records['StaffRotaApi']['d'];

		// Order the array of objects based on name attribute of each object.
		usort($data, function ($a, $b) {
			return ($a['WorkedByUser'] > $b['WorkedByUser']);
		});

		// Set the variables in the view in case they update the filters.
		$this->set(compact('data', 'date', 'department', 'user'));
	}

}
